#include <Servo.h>

#define SERVO_PIN 9
#define Analog_pin A0

Servo serv;
static int pos = 0;
char ch;
float distance;
long milliref;
int index;

float sharpVoltage[] = { 
  3.1, 2.7, 2.5, 2, 1.8, 1.6, 1.4, 1.3, 1.2, 1.1, 1.0, 0.9, 0.85 };

int sharpCms[] = { 
  3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };

const int E1 = 7;
const int E2 = 4;
const int M1 = 6;
const int M2 = 5;

void setup()
{
  pinMode(M1, OUTPUT);
  pinMode(M2, OUTPUT);
  pinMode(E1, OUTPUT);
  pinMode(E2, OUTPUT);
  pinMode(Analog_pin, INPUT);
  pinMode(SERVO_PIN, OUTPUT);
  serv.attach(SERVO_PIN);
  serv.write(90);
  Serial.begin(115200); 
}

void loop()
{
  if (Serial.available())
  {
    ;
  }
  char ch = Serial.read();
  switch(ch)
  {
  case '0'...'9':
    pos = pos * 10 + ch - '0';
    break;
  case 's':
    serv.write(pos);
    pos = 0;
    break;
  case 'a':
    avance();
    break;
  case 'r':
    recule();
    break;
  case 'd':
    droite();
    break;
  case 'g':
    gauche();
    break;
  case 'w':
    arret();
    break;
  }
  if(millis()>(milliref+1000))
  {
    milliref = milliref +1000;
    distance = analogRead(Analog_pin);
    distance = distance * 5.0;
    distance /= 1024.0;
   index = 0; 
    while(sharpVoltage[index] > distance && index <= 13)
    {
      index++;
    }
    Serial.print(sharpCms[index]);
  }
}

void avance()
{
  digitalWrite(E1, HIGH);
  digitalWrite(E2, HIGH);
  digitalWrite(M1, HIGH);
  digitalWrite(M2, HIGH);
}

void recule()
{
  digitalWrite(E1, HIGH);
  digitalWrite(E2, HIGH);
  digitalWrite(M1, LOW);
  digitalWrite(M2, LOW);
}

void droite()
{
  digitalWrite(E1, HIGH);
  digitalWrite(E2, HIGH);
  digitalWrite(M1, LOW);
  digitalWrite(M2, HIGH);
}

void gauche()
{
  digitalWrite(E1, HIGH);
  digitalWrite(E2, HIGH);
  digitalWrite(M1, HIGH);
  digitalWrite(M2, LOW);
}

void arret()
{
  digitalWrite(E1, LOW);
  digitalWrite(E2, LOW);
  digitalWrite(M1, HIGH);
  digitalWrite(M2, HIGH);
}



